Graphics 640,480,16
Global gfxtiles,gfxchicky,gfxghost1,gfxghost2,gfxghost3,gfxghost4
Global xpos,ypos,xspeed,yspeed,score=0,chframe=0,totalscore,lives=3,chalive=1,accruedscore
Global tileleft,tiletop,uptilex,uptiley,downtilex,downtiley,lefttilex,lefttiley,righttilex,righttiley,currenttilex,currenttiley
Global fruittemp,fruitstatus=0,playerfruit,fruitnotshown,fruitstart,fruitnotshown1,fruitstart1,playerchase,time,test
Global carrot1=1,carrot2=1,carrot3=1,carrot4=1,g1frame
Global titlescreen=1

Global g1lay,g1halfmove,g1xpos,g1ypos,g1xspeed,g1yspeed,g1status=0,g1dir=0
Global g1tileleft,g1tiletop,g1uptilex,g1uptiley,g1downtilex,g1downtiley,g1lefttilex,g1lefttiley,g1righttilex,g1righttiley,g1currenttilex,g1currenttiley
Global g1xdist,g1ydist,g1chase,g1up,g1down,g1left,g1right,g1chasemove,key

Global g2lay,g2halfmove,g2xpos,g2ypos,g2xspeed,g2yspeed,g2status=0,g2dir=0
Global g2tileleft,g2tiletop,g2uptilex,g2uptiley,g2downtilex,g2downtiley,g2lefttilex,g2lefttiley,g2righttilex,g2righttiley,g2currenttilex,g2currenttiley
Global g2xdist,g2ydist,g2chase,g2up,g2down,g2left,g2right,g2chasemove,g2key

Global g3lay,g3halfmove,g3xpos,g3ypos,g3xspeed,g3yspeed,g3status=0,g3dir=0
Global g3tileleft,g3tiletop,g3uptilex,g3uptiley,g3downtilex,g3downtiley,g3lefttilex,g3lefttiley,g3righttilex,g3righttiley,g3currenttilex,g3currenttiley
Global g3xdist,g3ydist,g3chase,g3up,g3down,g3left,g3right,g3chasemove,g3key

Global g4lay,g4halfmove,g4xpos,g4ypos,g4xspeed,g4yspeed,g4status=0,g4dir=0
Global g4tileleft,g4tiletop,g4uptilex,g4uptiley,g4downtilex,g4downtiley,g4lefttilex,g4lefttiley,g4righttilex,g4righttiley,g4currenttilex,g4currenttiley
Global g4xdist,g4ydist,g4chase,g4up,g4down,g4left,g4right,g4chasemove,g4key
Global chncarrot,chnegg,chneaten,chneating,chnlevel
xpos=296
ypos=256
g1xpos=296
g1ypos=216
g2xpos=296
g2ypos=216
g3xpos=296
g3ypos=216
g4xpos=296
g4ypos=216

Global sndcarrot=LoadSound("carrot.wav")
Global sndegg=LoadSound("egg.wav")
Global sndeaten=LoadSound("eaten.wav")
Global sndeating=LoadSound("eating.wav")
Global sndlevel=LoadSound("level.wav")
Global snd=LoadSound("gameover.wav")
gfxtiles=LoadAnimImage("tileset.bmp",20,20,0,20)
gfxchicky=LoadAnimImage("chicky28x28.bmp",28,28,0,4)
gfxghost1=LoadAnimImage("ghost128x28.bmp",28,28,0,4)
gfxghost2=LoadAnimImage("ghost128x28.bmp",28,28,0,4)
gfxghost3=LoadAnimImage("ghost128x28.bmp",28,28,0,4)
gfxghost4=LoadAnimImage("ghost128x28.bmp",28,28,0,4)

Global gfxgameover=LoadImage("gameover.bmp")
Global gfxcarrot1=LoadImage("carrot.bmp")
Global gfxcarrot2=LoadImage("carrot.bmp")
Global gfxcarrot3=LoadImage("carrot.bmp")
Global gfxcarrot4=LoadImage("carrot.bmp")
Global gfxleft=LoadImage("left.bmp")
Global gfxfruit=LoadImage("fruit.bmp")
Global gfxtitle=LoadImage("title.jpg")
MaskImage gfxleft,255,255,255
Global gfxright=LoadImage("right.bmp")
MaskImage gfxright,255,255,255
Global frameTimer=CreateTimer(40)

Dim tile(100,100)
loadmap()
;score=150:;boosted temporarily to check level reloading
SetBuffer BackBuffer()
If titlescreen=1 Then drawtitlescreen()
While Not KeyDown(14)
Flip
Cls
SeedRnd MilliSecs() 
WaitTimer(frameTimer) ; Pause until the timer reaches 50
If KeyDown(1)
	restartmap()
	titlescreen=1
EndIf
If titlescreen=1 Then drawtitlescreen()
drawmap()
drawcarrots()
If chalive=1 Then DrawImage gfxchicky,xpos,ypos,chframe
DrawImage gfxghost1,g1xpos,g1ypos,g1frame
DrawImage gfxghost2,g2xpos,g2ypos,g1frame
DrawImage gfxghost3,g3xpos,g3ypos,g1frame
DrawImage gfxghost4,g4xpos,g4ypos,g1frame
tileposition()
g1tileposition()
g2tileposition()
g3tileposition()
g4tileposition()
moveplayer1()
moveghost1()
moveghost2()
moveghost3()
moveghost4()
fruit()
DrawImage gfxleft,24,0
DrawImage gfxright,495,0
Text 200,10,"Score " +totalscore
Text 300,10,"Lives " +lives
Wend

Function loadmap()
Restore mapdata
For a = 0 To 23
For b = 0 To 31
Read tile(b,a)
Next
Next
End Function


Function drawmap()
drawpixelposx=0
drawpixelposy=0
For a= 0 To 23
For b=0 To 31
frame=tile(b,a)
DrawImage gfxtiles,drawpixelposx,drawpixelposy,frame
;DrawImage gfxtiles,1,1
drawpixelposx=drawpixelposx+20
Next 
drawpixelposx=0
drawpixelposy=drawpixelposy+20
Next 

End Function

Function tileposition()
currenttilex=(xpos+4)/20
currenttiley=(ypos+4)/20
tileleft=currenttilex*20-4
tiletop=currenttiley*20-4
lefttilex=(xpos+3)/20
lefttiley=(ypos+8)/20
righttilex=(xpos+24)/20
righttiley=(ypos+4)/20
uptilex=(xpos+5)/20
uptiley=(ypos+3)/20
downtilex=(xpos+5)/20
downtiley=(ypos+24)/20
End Function

Function moveplayer1()
If KeyDown(200) Or yspeed= -2
	If xpos=tileleft
		If tile(uptilex,uptiley) = 0 Or tile(uptilex,uptiley) =16
			yspeed= -2:xspeed=0
		Else yspeed = 0
		EndIf
	EndIf
EndIf
If KeyDown(208)Or yspeed =2
	If xpos=tileleft
		If tile(downtilex,downtiley) =0 Or tile(downtilex,downtiley) =16
			yspeed= 2:xspeed=0
		Else yspeed=0
		EndIf
	EndIf
EndIf
If KeyDown(203) Or xspeed= -2
	If ypos=tiletop
		If tile(lefttilex,lefttiley)=0 Or tile(lefttilex,lefttiley)=16
			xspeed= -2:yspeed=0
		Else xspeed=0
		EndIf
	EndIf
EndIf
If KeyDown(205) Or xspeed= 2
	If ypos=tiletop
		If tile(righttilex,righttiley)=0 Or tile(righttilex,righttiley)=16
			xspeed=2:yspeed=0
		Else xspeed=0
		EndIf
	EndIf
EndIf
If xpos<=100 Then xpos=490
If xpos>=494 Then xpos=100
If chalive=0
	xspeed=0:yspeed=0
	value=GetKey()
	If value>31 Then chalive=1
EndIf
	
If xpos=tileleft And ypos=tiletop
	If tile(currenttilex,currenttiley)=0 
		tile(currenttilex,currenttiley)=16
		PlaySound sndegg

		score=score+1:totalscore=totalscore+1:accruedscore=accruedscore+1
		If accruedscore>200 And lives<=3 Then lives=lives+1:accruedscore=0
			
	EndIf
EndIf
If score >=176 Then restartmap()

If xspeed=2 Then chframe=1
If xspeed=-2 Then chframe=0
xpos=xpos+xspeed
ypos=ypos+yspeed
End Function

Function moveghost1()
If g1status=0
	a=Rand(1,150)
	If a=3 And playerchase=0 
		g1status=1
		g1xpos=296
		g1ypos=176
		g1dir=Rand(1,2)
		Select g1dir
		Case 1
		g1xspeed= -2:g1yspeed=0
		Case 2
		g1xspeed=2:g1yspeed=0
		End Select
	EndIf
EndIf
;debug mode    If KeyDown(16) Then Stop
If KeyDown(17) Then playerchase=1

If g1xpos<98 Or g1xpos>490 Then g1xspeed=g1xspeed* -1

g1xdist=xpos-g1xpos:g1xdist=Abs(g1xdist)
g1ydist=ypos-g1ypos:g1ydist=Abs(g1ydist)
If chalive=0 Then g1xdist=1000:g1ydist=1000

If g1xdist<=80 And g1ydist<=80 Then g1chase=1
If playerchase=1 Then g1chase=0

;if at junction
If g1xspeed=2 Or g1xspeed=-2
	If g1xpos=g1tileleft And g1ypos=g1tiletop
		If tile(g1uptilex,g1uptiley) = 0 Or tile(g1uptilex,g1uptiley) =16
				a=Rand(1,2)
				If a=1 Then key=200:g1status=1
				If g1chase =1 Then g1up=1
		EndIf
		If tile(g1downtilex,g1downtiley) = 0 Or tile(g1downtilex,g1downtiley) =16
				a=Rand(1,2)
				If a=1 Then key=208
				If g1chase=1 Then g1down=1
		EndIf
	EndIf
EndIf
If g1yspeed=2 Or g1yspeed=-2
	If g1ypos=g1tiletop And g1xpos=g1tileleft
		If tile(g1lefttilex,g1lefttiley) = 0 Or tile(g1lefttilex,g1lefttiley) =16
				a=Rand(1,2)
				If a=1 Then key=203
				If g1chase=1 Then g1left=1
		
		EndIf
		If tile(g1righttilex,g1righttiley) = 0 Or tile(g1righttilex,g1righttiley) =16
				a=Rand(1,2)
				If a=1 Then key=205
				If g1chase=1 Then g1right=1
		
		EndIf
		
	EndIf
EndIf
;g1chasedirection()
If g1xspeed=0 And g1yspeed=0
		a=Rand(1,4)
		Select a
		Case 1 key=200
		Case 2 key=208
		Case 3 key=203
		Case 4 key=205
		End Select
	;g1chasedirection()			
EndIf
If g1status=1 And g1xpos=g1tileleft And g1ypos=g1tiletop Then g1chasedirection()
g1up=0
g1down=0
g1left=0
g1right=0
If key=200 Or g1yspeed= -2

	If g1xpos=g1tileleft
		If tile(g1uptilex,g1uptiley) = 0 Or tile(g1uptilex,g1uptiley) =16
			If g1halfmove=0 Then g1yspeed= -2:g1xspeed=0
		Else 
			If g1halfmove=0 Then g1yspeed = 0
		EndIf
	EndIf

EndIf
If Key=208 Or g1yspeed =2	
	If g1xpos=g1tileleft
		If tile(g1downtilex,g1downtiley) =0 Or tile(g1downtilex,g1downtiley) =16
			If g1halfmove=0 Then g1yspeed=2:g1xspeed=0
		Else 
			If g1halfmove=0 Then g1yspeed=0
		EndIf
	EndIf
EndIf
If Key=203 Or g1xspeed= -2
	If g1ypos=g1tiletop
		If tile(g1lefttilex,g1lefttiley)=0 Or tile(g1lefttilex,g1lefttiley)=16
		If g1halfmove=0 Then g1xspeed= -2:g1yspeed=0
		Else 
			If g1halfmove=0 Then g1xspeed=0
	EndIf
	EndIf
EndIf
If Key=205 Or g1xspeed= 2
	If g1ypos=g1tiletop
		If tile(g1righttilex,g1righttiley)=0 Or tile(g1righttilex,g1righttiley)=16
		If g1halfmove=0 Then g1xspeed=2:g1yspeed=0
		Else 
			If g1halfmove=0 Then g1xspeed=0
		EndIf
	EndIf
EndIf
;ghost laying egg code
If g1lay=1
	If g1xpos=g1tileleft And g1ypos=g1tiletop
		If tile(g1currenttilex,g1currenttiley)=0 
			tile(g1currenttilex,g1currenttiley)=16
				score=score+1:accruedscore=accruedscore+1:totalscore=totalscore+1
		EndIf
	EndIf
EndIf

If playerchase=1 Or g1halfmove=1
	If g1xspeed=2 And  g1halfmove=0 Then g1xspeed=1
	If g1xspeed= -2 And g1halfmove=0 Then g1xspeed= -1
	If g1yspeed=2 And  g1halfmove=0 Then  g1yspeed=1
	If g1yspeed= -2 And  g1halfmove=0 Then  g1yspeed= -1
	If g1xspeed=1 Or g1xspeed= -1 Or g1yspeed=1 Or g1yspeed= -1
		g1halfmove=g1halfmove+1
		If g1halfmove=2 Then g1halfmove=0
	EndIf
g1frame=1
EndIf
;If g1halfmove=1
;	If g1xspeed=2 Then g1xspeed=1
;	If g1xspeed= -2 Then g1xspeed= -1
;	If g1yspeed=2 Then g1yspeed=1
;	If g1yspeed= -2 Then g1yspeed= -1
;EndIf
g1xpos=g1xpos+g1xspeed
g1ypos=g1ypos+g1yspeed
If playerchase=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost1,g1xpos,g1ypos) = 1 
	g1status=0:g1xspeed=0:g1yspeed=0:totalscore=totalscore+20:accruedscore=accruedscore+20:g1halfmove=0
	g1xpos=296:g1ypos=216
	g1frame=0
	PlaySound sndeating
EndIf
If playerchase=0 Then g1frame=0
If g1lay=1
		g1frame=2
		If g1xspeed= -2 Or g1xspeed= -1 Then g1frame=2
		If g1xspeed=2 Or g1xspeed= -2 Then g1frame=3
		If playerchase=1 Then g1frame=1
EndIf

If chalive=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost1,g1xpos,g1ypos) = 1 And playerchase=0 
	lives=lives-1:xpos=296:ypos=256:chalive=0:xspeed=0:yspeed=0:accruedscore=0
	PlaySound sndeaten
EndIf
	
If lives=0 Then gameover()

End Function

Function g1tileposition()
g1currenttilex=(g1xpos+4)/20
g1currenttiley=(g1ypos+4)/20
g1tileleft=g1currenttilex*20-4
g1tiletop=g1currenttiley*20-4
g1lefttilex=(g1xpos+3)/20
g1lefttiley=(g1ypos+8)/20
g1righttilex=(g1xpos+24)/20
g1righttiley=(g1ypos+4)/20
g1uptilex=(g1xpos+5)/20
g1uptiley=(g1ypos+3)/20
g1downtilex=(g1xpos+5)/20
g1downtiley=(g1ypos+24)/20
End Function

Function g1chasedirection()
a=Rand(1,4)
If a =4 Then g1chase=0
	If g1chase=1
			If tile(g1uptilex,g1uptiley) = 0 Or tile(g1uptilex,g1uptiley) =16 Then g1up=1
			If tile(g1downtilex,g1downtiley) = 0 Or tile(g1downtilex,g1downtiley) =16 Then g1down=1
			If tile(g1lefttilex,g1lefttiley) = 0 Or tile(g1lefttilex,g1lefttiley) =16 Then g1left=1
			If tile(g1righttilex,g1righttiley) = 0 Or tile(g1righttilex,g1righttiley) =16 Then g1right=1
				If g1up=1 And ypos<=g1ypos
				key=200;:Stop
				If g1left=1 And xpos<=g1xpos And g1xdist>=g1ydist 
					key=203
				Else g1left=0
				EndIf
				If g1right=1 And xpos>=g1xpos And g1xdist>=g1ydist
					key=205
				Else g1right=0
				EndIf
			EndIf
			If g1down=1 And ypos>=g1ypos
				key=208;:Stop
				If g1left=1 And xpos<=g1xpos And g1xdist>=g1ydist
					key=203
				Else g1left=0
				EndIf
				If g1right=1 And xpos>=g1xpos And g1xdist>=g1ydist
					key=205
				Else g1right=0
				EndIf
			EndIf
			If g1left=1 And xpos<=g1xpos
				key=203;:Stop
				If g1up=1 And ypos<=g1ypos And g1ydist>=g1xdist
					key=200
				Else g1up=0
				EndIf
				If g1down=1 And ypos>=g1ypos And g1ydist>=g1xdist
					key=208
				Else g1down=0
				EndIf
			EndIf
			If g1right=1 And xpos>=g1xpos
				key=205;:Stop
				If g1up=1 And ypos<=g1ypos And g1ydist>=g1xdist
					key=200
				Else g1up=0
				EndIf
				If g1down=1 And ypos>=g1ypos And g1ydist>=g1xdist
					key=208
				Else g1down=0
				EndIf
			EndIf
		EndIf
	End Function

Function moveghost2()
If g2status=0 And playerchase=0
	a=Rand(1,150)
	If a=4 
		g2status=1
		g2xpos=296
		g2ypos=176
		g2dir=Rand(1,2)
		Select g2dir
		Case 1
		g2xspeed= -2:g2yspeed=0
		Case 2
		g2xspeed=2:g2yspeed=0
		End Select
	EndIf
EndIf
If KeyDown(16) Then Stop
If g2xpos<98 Or g2xpos>490 Then g2xspeed=g2xspeed* -1

g2xdist=xpos-g2xpos:g2xdist=Abs(g2xdist)
g2ydist=ypos-g2ypos:g2ydist=Abs(g2ydist)
If chalive=0 Then g2xdist=1000:g2ydist=1000

If g2xdist<=80 And g2ydist<=80 Then g2chase=1
If playerchase=1 Then g2chase=0

;if at junction
If g2xspeed=2 Or g2xspeed=-2
	If g2xpos=g2tileleft And g2ypos=g2tiletop
		If tile(g2uptilex,g2uptiley) = 0 Or tile(g2uptilex,g2uptiley) =16
				a=Rand(1,2)
				If a=1 Then g2key=200:g2status=1
				If g2chase =1 Then g2up=1
		EndIf
		If tile(g2downtilex,g2downtiley) = 0 Or tile(g2downtilex,g2downtiley) =16
				a=Rand(1,2)
				If a=1 Then g2key=208
				If g2chase=1 Then g2down=1
		EndIf
	EndIf
EndIf
If g2yspeed=2 Or g2yspeed=-2
	If g2ypos=g2tiletop And g2xpos=g2tileleft
		If tile(g2lefttilex,g2lefttiley) = 0 Or tile(g2lefttilex,g2lefttiley) =16
				a=Rand(1,2)
				If a=1 Then g2key=203
				If g2chase=1 Then g2left=1
		
		EndIf
		If tile(g2righttilex,g2righttiley) = 0 Or tile(g2righttilex,g2righttiley) =16
				a=Rand(1,2)
				If a=1 Then g2key=205
				If g2chase=1 Then g2right=1
		
		EndIf
		
	EndIf
EndIf
;g2chasedirection()
If g2xspeed=0 And g2yspeed=0
		a=Rand(1,4)
		Select a
		Case 1 g2key=200
		Case 2 g2key=208
		Case 3 g2key=203
		Case 4 g2key=205
		End Select
	;g2chasedirection()			
EndIf
If g2status=1 And g2xpos=g2tileleft And g2ypos=g2tiletop Then g2chasedirection()
g2up=0
g2down=0
g2left=0
g2right=0
If g2key=200 Or g2yspeed= -2

	If g2xpos=g2tileleft
		If tile(g2uptilex,g2uptiley) = 0 Or tile(g2uptilex,g2uptiley) =16
		If g2halfmove=0 And g2halfmove=0  Then g2yspeed= -2:g2xspeed=0
		Else 
			If g2halfmove=0 Then g2yspeed = 0
		EndIf
	EndIf

EndIf
If g2key=208 Or g2yspeed =2	
	If g2xpos=g2tileleft
		If tile(g2downtilex,g2downtiley) =0 Or tile(g2downtilex,g2downtiley) =16
		If g2halfmove=0 And  g2halfmove=0 Then  g2yspeed=2:g2xspeed=0
		Else 
			If g2halfmove=0 Then g2yspeed=0
		EndIf
	EndIf
EndIf
If g2key=203 Or g2xspeed= -2
	If g2ypos=g2tiletop
		If tile(g2lefttilex,g2lefttiley)=0 Or tile(g2lefttilex,g2lefttiley)=16
		If g2halfmove=0 And g2halfmove=0 Then  g2xspeed= -2:g2yspeed=0
		Else 
			If g2halfmove=0 Then g2xspeed=0
	EndIf
	EndIf
EndIf
If g2key=205 Or g2xspeed= 2
	If g2ypos=g2tiletop
		If tile(g2righttilex,g2righttiley)=0 Or tile(g2righttilex,g2righttiley)=16
		If g2halfmove=0 And g2halfmove=0 Then  g2xspeed=2:g2yspeed=0
		Else 
			If g2halfmove=0 Then g2xspeed=0
		EndIf
	EndIf
EndIf
;ghost laying egg code
If g2lay=1
	If g2xpos=g2tileleft And g2ypos=g2tiletop
		If tile(g2currenttilex,g2currenttiley)=0 
			tile(g2currenttilex,g2currenttiley)=16
				score=score+1:accruedscore=accruedscore+1:totalscore=totalscore+1
		EndIf
	EndIf
EndIf

If playerchase=1 Or g2halfmove=1
	If g2xspeed=2 And g2halfmove=0  Then g2xspeed=1
	If g2xspeed= -2 And  g2halfmove=0 Then  g2xspeed= -1
	If g2yspeed=2 And g2halfmove=0 Then  g2yspeed=1
	If g2yspeed= -2 And  g2halfmove=0 Then  g2yspeed= -1
	If g2xspeed=1 Or g2xspeed= -1 Or g2yspeed=1 Or g2yspeed= -1
		g2halfmove=g2halfmove+1
		If g2halfmove=2 Then g2halfmove=0
	EndIf
g2frame=1
EndIf
;If g2halfmove=1
;	If g2xspeed=2 Then g2xspeed=1
;	If g2xspeed= -2 Then g2xspeed= -1
;	If g2yspeed=2 Then g2yspeed=1
;	If g2yspeed= -2 Then g2yspeed= -1
;EndIf
g2xpos=g2xpos+g2xspeed
g2ypos=g2ypos+g2yspeed
If playerchase=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost2,g2xpos,g2ypos) = 1 
	g2status=0:g2xspeed=0:g2yspeed=0:totalscore=totalscore+20:accruedscore=accruedscore+20:g2halfmove=0
	g2xpos=296:g2ypos=216
	g2frame=0:PlaySound sndeating
EndIf
If playerchase=0 Then g2frame=0
If g2lay=1
		g2frame=2
		If g2xspeed= -2 Then g2frame=2
		If g2xspeed=2 Then g2frame=3
		If playerchase=1 Then g2frame=1
EndIf

If chalive=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost2,g2xpos,g2ypos) = 1 And playerchase=0 
	lives=lives-1:xpos=296:ypos=256:chalive=0:xspeed=0:yspeed=0:accruedscore=0
	PlaySound sndeaten
EndIf
	
If lives=0 Then gameover()

End Function

Function g2tileposition()
g2currenttilex=(g2xpos+4)/20
g2currenttiley=(g2ypos+4)/20
g2tileleft=g2currenttilex*20-4
g2tiletop=g2currenttiley*20-4
g2lefttilex=(g2xpos+3)/20
g2lefttiley=(g2ypos+8)/20
g2righttilex=(g2xpos+24)/20
g2righttiley=(g2ypos+4)/20
g2uptilex=(g2xpos+5)/20
g2uptiley=(g2ypos+3)/20
g2downtilex=(g2xpos+5)/20
g2downtiley=(g2ypos+24)/20
End Function

Function g2chasedirection()
a=Rand(1,4)
If a =4 Then g2chase=0
	If g2chase=1
			If tile(g2uptilex,g2uptiley) = 0 Or tile(g2uptilex,g2uptiley) =16 Then g2up=1
			If tile(g2downtilex,g2downtiley) = 0 Or tile(g2downtilex,g2downtiley) =16 Then g2down=1
			If tile(g2lefttilex,g2lefttiley) = 0 Or tile(g2lefttilex,g2lefttiley) =16 Then g2left=1
			If tile(g2righttilex,g2righttiley) = 0 Or tile(g2righttilex,g2righttiley) =16 Then g2right=1
				If g2up=1 And ypos<=g2ypos
				g2key=200;:Stop
				If g2left=1 And xpos<=g2xpos And g2xdist>=g2ydist 
					g2key=203
				Else g2left=0
				EndIf
				If g2right=1 And xpos>=g2xpos And g2xdist>=g2ydist
					g2key=205
				Else g2right=0
				EndIf
			EndIf
			If g2down=1 And ypos>=g2ypos
				g2key=208;:Stop
				If g2left=1 And xpos<=g2xpos And g2xdist>=g2ydist
					g2key=203
				Else g2left=0
				EndIf
				If g2right=1 And xpos>=g2xpos And g2xdist>=g2ydist
					g2key=205
				Else g2right=0
				EndIf
			EndIf
			If g2left=1 And xpos<=g2xpos
				g2key=203;:Stop
				If g2up=1 And ypos<=g2ypos And g2ydist>=g2xdist
					g2key=200
				Else g2up=0
				EndIf
				If g2down=1 And ypos>=g2ypos And g2ydist>=g2xdist
					g2key=208
				Else g2down=0
				EndIf
			EndIf
			If g2right=1 And xpos>=g2xpos
				g2key=205;:Stop
				If g2up=1 And ypos<=g2ypos And g2ydist>=g2xdist
					g2key=200
				Else g2up=0
				EndIf
				If g2down=1 And ypos>=g2ypos And g2ydist>=g2xdist
					g2key=208
				Else g2down=0
				EndIf
			EndIf
		EndIf
	End Function

Function moveghost3()
If g3status=0 And playerchase=0
	a=Rand(1,150)
	If a=5 
		g3status=1
		g3xpos=296
		g3ypos=176
		g3dir=Rand(1,2)
		Select g3dir
		Case 1
			g3xspeed= -2:g3yspeed=0
		Case 2
			g3xspeed=2:g3yspeed=0
		End Select
	EndIf
EndIf
If KeyDown(16) Then Stop
If g3xpos<98 Or g3xpos>490 Then g3xspeed=g3xspeed* -1

g3xdist=xpos-g3xpos:g3xdist=Abs(g3xdist)
g3ydist=ypos-g3ypos:g3ydist=Abs(g3ydist)
If chalive=0 Then g3xdist=1000:g3ydist=1000

If g3xdist<=80 And g3ydist<=80 Then g3chase=1
If playerchase=1 Then g3chase=0

;if at junction
If g3xspeed=2 Or g3xspeed=-2
	If g3xpos=g3tileleft And g3ypos=g3tiletop
		If tile(g3uptilex,g3uptiley) = 0 Or tile(g3uptilex,g3uptiley) =16
				a=Rand(1,2)
				If a=1 Then g3key=200:g3status=1
				If g3chase =1 Then g3up=1
		EndIf
		If tile(g3downtilex,g3downtiley) = 0 Or tile(g3downtilex,g3downtiley) =16
				a=Rand(1,2)
				If a=1 Then g3key=208
				If g3chase=1 Then g3down=1
		EndIf
	EndIf
EndIf
If g3yspeed=2 Or g3yspeed=-2
	If g3ypos=g3tiletop And g3xpos=g3tileleft
		If tile(g3lefttilex,g3lefttiley) = 0 Or tile(g3lefttilex,g3lefttiley) =16
				a=Rand(1,2)
				If a=1 Then g3key=203
				If g3chase=1 Then g3left=1
		
		EndIf
		If tile(g3righttilex,g3righttiley) = 0 Or tile(g3righttilex,g3righttiley) =16
				a=Rand(1,2)
				If a=1 Then g3key=205
				If g3chase=1 Then g3right=1
		
		EndIf
		
	EndIf
EndIf
;g3chasedirection()
If g3xspeed=0 And g3yspeed=0
		a=Rand(1,4)
		Select a
		Case 1 g3key=200
		Case 2 g3key=208
		Case 3 g3key=203
		Case 4 g3key=205
		End Select
	;g3chasedirection()			
EndIf
If g3status=1 And g3xpos=g3tileleft And g3ypos=g3tiletop Then g3chasedirection()
g3up=0
g3down=0
g3left=0
g3right=0
If g3key=200 Or g3yspeed= -2

	If g3xpos=g3tileleft
		If tile(g3uptilex,g3uptiley) = 0 Or tile(g3uptilex,g3uptiley) =16
		If g3halfmove=0 And  g3halfmove=0 Then  g3yspeed= -2:g3xspeed=0
		Else 
			If g3halfmove=0 Then g3yspeed = 0
		EndIf
	EndIf

EndIf
If g3key=208 Or g3yspeed =2	
	If g3xpos=g3tileleft
		If tile(g3downtilex,g3downtiley) =0 Or tile(g3downtilex,g3downtiley) =16
		If g3halfmove=0 Then g3yspeed=2:g3xspeed=0
		Else 
			If g3halfmove=0 Then g3yspeed=0
		EndIf
	EndIf
EndIf
If g3key=203 Or g3xspeed= -2
	If g3ypos=g3tiletop
		If tile(g3lefttilex,g3lefttiley)=0 Or tile(g3lefttilex,g3lefttiley)=16
		If g3halfmove=0 Then g3xspeed= -2:g3yspeed=0
		Else 
			If g3halfmove=0 Then g3xspeed=0
	EndIf
	EndIf
EndIf
If g3key=205 Or g3xspeed= 2
	If g3ypos=g3tiletop
		If tile(g3righttilex,g3righttiley)=0 Or tile(g3righttilex,g3righttiley)=16
		If g3halfmove=0 Then g3xspeed=2:g3yspeed=0
		Else 
			If g3halfmove=0 Then g3xspeed=0
		EndIf
	EndIf
EndIf
;ghost laying egg code
If g3lay=1
	If g3xpos=g3tileleft And g3ypos=g3tiletop
		If tile(g3currenttilex,g3currenttiley)=0 
			tile(g3currenttilex,g3currenttiley)=16
				score=score+1:accruedscore=accruedscore+1:totalscore=totalscore+1
		EndIf
	EndIf
EndIf

If playerchase=1 Or g3halfmove=1
	If g3xspeed=2 And g3halfmove=0 Then g3xspeed=1
	If g3xspeed= -2 And g3halfmove=0  Then g3xspeed= -1
	If g3yspeed=2 And  g3halfmove=0 Then  g3yspeed=1
	If g3yspeed= -2 And g3halfmove=0 Then  g3yspeed= -1
	If g3xspeed=1 Or g3xspeed= -1 Or g3yspeed=1 Or g3yspeed= -1
		g3halfmove=g3halfmove+1
		If g3halfmove=2 Then g3halfmove=0
	EndIf
g3frame=1
EndIf
;If g3halfmove=1
;	If g3xspeed=2 Then g3xspeed=1
;	If g3xspeed= -2 Then g3xspeed= -1
;	If g3yspeed=2 Then g3yspeed=1
;	If g3yspeed= -2 Then g3yspeed= -1
;EndIf
g3xpos=g3xpos+g3xspeed
g3ypos=g3ypos+g3yspeed
If playerchase=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost3,g3xpos,g3ypos) = 1 
	g3status=0:g3xspeed=0:g3yspeed=0:totalscore=totalscore+20:accruedscore=accruedscore+20:g3halfmove=0
	g3xpos=296:g3ypos=216
	g3frame=0:PlaySound sndeating
EndIf
If playerchase=0 Then g3frame=0
If g3lay=1
		g3frame=2
		If g3xspeed= -2 Or g3xpeed= -1 Then g3frame=2
		If g3xspeed=2 Or g3xspeed= 1Then g3frame=3
		If playerchase=1 Then g3frame=1
EndIf

If chalive=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost3,g3xpos,g3ypos) = 1 And playerchase=0 
	lives=lives-1:xpos=296:ypos=256:chalive=0:xspeed=0:yspeed=0:accruedscore=0
	PlaySound sndeaten
EndIf
	
If lives=0 Then gameover()

End Function

Function g3tileposition()
g3currenttilex=(g3xpos+4)/20
g3currenttiley=(g3ypos+4)/20
g3tileleft=g3currenttilex*20-4
g3tiletop=g3currenttiley*20-4
g3lefttilex=(g3xpos+3)/20
g3lefttiley=(g3ypos+8)/20
g3righttilex=(g3xpos+24)/20
g3righttiley=(g3ypos+4)/20
g3uptilex=(g3xpos+5)/20
g3uptiley=(g3ypos+3)/20
g3downtilex=(g3xpos+5)/20
g3downtiley=(g3ypos+24)/20
End Function

Function g3chasedirection()
a=Rand(1,4)
If a =4 Then g3chase=0
	If g3chase=1
			If tile(g3uptilex,g3uptiley) = 0 Or tile(g3uptilex,g3uptiley) =16 Then g3up=1
			If tile(g3downtilex,g3downtiley) = 0 Or tile(g3downtilex,g3downtiley) =16 Then g3down=1
			If tile(g3lefttilex,g3lefttiley) = 0 Or tile(g3lefttilex,g3lefttiley) =16 Then g3left=1
			If tile(g3righttilex,g3righttiley) = 0 Or tile(g3righttilex,g3righttiley) =16 Then g3right=1
				If g3up=1 And ypos<=g3ypos
				g3key=200;:Stop
				If g3left=1 And xpos<=g3xpos And g3xdist>=g3ydist 
					g3key=203
				Else g3left=0
				EndIf
				If g3right=1 And xpos>=g3xpos And g3xdist>=g3ydist
					g3key=205
				Else g3right=0
				EndIf
			EndIf
			If g3down=1 And ypos>=g3ypos
				g3key=208;:Stop
				If g3left=1 And xpos<=g3xpos And g3xdist>=g3ydist
					g3key=203
				Else g3left=0
				EndIf
				If g3right=1 And xpos>=g3xpos And g3xdist>=g3ydist
					g3key=205
				Else g3right=0
				EndIf
			EndIf
			If g3left=1 And xpos<=g3xpos
				g3key=203;:Stop
				If g3up=1 And ypos<=g3ypos And g3ydist>=g3xdist
					g3key=200
				Else g3up=0
				EndIf
				If g3down=1 And ypos>=g3ypos And g3ydist>=g3xdist
					g3key=208
				Else g3down=0
				EndIf
			EndIf
			If g3right=1 And xpos>=g3xpos
				g3key=205;:Stop
				If g3up=1 And ypos<=g3ypos And g3ydist>=g3xdist
					g3key=200
				Else g3up=0
				EndIf
				If g3down=1 And ypos>=g3ypos And g3ydist>=g3xdist
					g3key=208
				Else g3down=0
				EndIf
			EndIf
		EndIf
	End Function

Function moveghost4()
If g4status=0 And playerchase=0
	a=Rand(1,150)
	If a=6 
		g4status=1
		g4xpos=296
		g4ypos=176
		g4dir=Rand(1,2)
		Select g4dir
		Case 1
		g4xspeed= -2:g4yspeed=0
		Case 2
		g4xspeed=2:g4yspeed=0
		End Select
	EndIf
EndIf
If KeyDown(16) Then Stop
If g4xpos<98 Or g4xpos>490 Then g4xspeed=g4xspeed* -1

g4xdist=xpos-g4xpos:g4xdist=Abs(g4xdist)
g4ydist=ypos-g4ypos:g4ydist=Abs(g4ydist)
If chalive=0 Then g4xdist=1000:g4ydist=1000

If g4xdist<=80 And g4ydist<=80 Then g4chase=1
If playerchase=1 Then g4chase=0

;if at junction
If g4xspeed=2 Or g4xspeed=-2
	If g4xpos=g4tileleft And g4ypos=g4tiletop
		If tile(g4uptilex,g4uptiley) = 0 Or tile(g4uptilex,g4uptiley) =16
				a=Rand(1,2)
				If a=1 Then g4key=200:g4status=1
				If g4chase =1 Then g4up=1
		EndIf
		If tile(g4downtilex,g4downtiley) = 0 Or tile(g4downtilex,g4downtiley) =16
				a=Rand(1,2)
				If a=1 Then g4key=208
				If g4chase=1 Then g4down=1
		EndIf
	EndIf
EndIf
If g4yspeed=2 Or g4yspeed=-2
	If g4ypos=g4tiletop And g4xpos=g4tileleft
		If tile(g4lefttilex,g4lefttiley) = 0 Or tile(g4lefttilex,g4lefttiley) =16
				a=Rand(1,2)
				If a=1 Then g4key=203
				If g4chase=1 Then g4left=1
		
		EndIf
		If tile(g4righttilex,g4righttiley) = 0 Or tile(g4righttilex,g4righttiley) =16
				a=Rand(1,2)
				If a=1 Then g4key=205
				If g4chase=1 Then g4right=1
		
		EndIf
		
	EndIf
EndIf
;g4chasedirection()
If g4xspeed=0 And g4yspeed=0
		a=Rand(1,4)
		Select a
		Case 1 g4key=200
		Case 2 g4key=208
		Case 3 g4key=203
		Case 4 g4key=205
		End Select
	;g4chasedirection()			
EndIf
If g4status=1 And g4xpos=g4tileleft And g4ypos=g4tiletop Then g4chasedirection()
g4up=0
g4down=0
g4left=0
g4right=0
If g4key=200 Or g4yspeed= -2

	If g4xpos=g4tileleft
		If tile(g4uptilex,g4uptiley) = 0 Or tile(g4uptilex,g4uptiley) =16
		If g4halfmove=0 Then g4yspeed= -2:g4xspeed=0
		Else 
			If g4halfmove=0 Then g4yspeed = 0
		EndIf
	EndIf

EndIf
If g4key=208 Or g4yspeed =2	
	If g4xpos=g4tileleft
		If tile(g4downtilex,g4downtiley) =0 Or tile(g4downtilex,g4downtiley) =16
		If g4halfmove=0 Then g4yspeed=2:g4xspeed=0
		Else 
			If g4halfmove=0 Then g4yspeed=0
		EndIf
	EndIf
EndIf
If g4key=203 Or g4xspeed= -2
	If g4ypos=g4tiletop
		If tile(g4lefttilex,g4lefttiley)=0 Or tile(g4lefttilex,g4lefttiley)=16
		If g4halfmove=0 Then g4xspeed= -2:g4yspeed=0
		Else 
			If g4halfmove=0 Then g4xspeed=0
	EndIf
	EndIf
EndIf
If g4key=205 Or g4xspeed= 2
	If g4ypos=g4tiletop
		If tile(g4righttilex,g4righttiley)=0 Or tile(g4righttilex,g4righttiley)=16
		If g4halfmove=0 Then g4xspeed=2:g4yspeed=0
		Else 
			If g4halfmove=0 Then g4xspeed=0
		EndIf
	EndIf
EndIf
;ghost laying egg code
If g4lay=1
	If g4xpos=g4tileleft And g4ypos=g4tiletop
		If tile(g4currenttilex,g4currenttiley)=0 
			tile(g4currenttilex,g4currenttiley)=16
				score=score+1:accruedscore=accruedscore+1:totalscore=totalscore+1
		EndIf
	EndIf
EndIf

If playerchase=1 Or g4halfmove=1
	If g4xspeed=2 And g4halfmove=0 Then g4xspeed=1
	If g4xspeed= -2 And g4halfmove=0 Then  g4xspeed= -1
	If g4yspeed=2 And  g4halfmove=0 Then  g4yspeed=1
	If g4yspeed= -2 And  g4halfmove=0 Then  g4yspeed= -1
	If g4xspeed=1 Or g4xspeed= -1 Or g4yspeed=1 Or g4yspeed= -1
		g4halfmove=g4halfmove+1
		If g4halfmove=2 Then g4halfmove=0
	EndIf
g4frame=1
EndIf
;If g4halfmove=1
;	If g4xspeed=2 Then g4xspeed=1
;	If g4xspeed= -2 Then g4xspeed= -1
;	If g4yspeed=2 Then g4yspeed=1
;	If g4yspeed= -2 Then g4yspeed= -1
;EndIf
g4xpos=g4xpos+g4xspeed
g4ypos=g4ypos+g4yspeed
If playerchase=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost4,g4xpos,g4ypos) = 1 
	g4status=0:g4xspeed=0:g4yspeed=0:totalscore=totalscore+20:accruedscore=accruedscore+20:g4halfmove=0
	g4xpos=296:g4ypos=216
	g4frame=0:PlaySound sndeating
EndIf
If playerchase=0 Then g4frame=0
If g4lay=1
		g4frame=2
		If g4xspeed= -2 Or g4xpeed= -1 Then g4frame=2
		If g4xspeed=2 Or g4xspeed= 1 Then g4frame=3
		If playerchase=1 Then g4frame=1
EndIf

If chalive=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxghost4,g4xpos,g4ypos) = 1 And playerchase=0 
	lives=lives-1:xpos=296:ypos=256:chalive=0:xspeed=0:yspeed=0:accruedscore=0
	PlaySound sndeaten
EndIf
	
If lives=0 Then gameover()

End Function

Function g4tileposition()
g4currenttilex=(g4xpos+4)/20
g4currenttiley=(g4ypos+4)/20
g4tileleft=g4currenttilex*20-4
g4tiletop=g4currenttiley*20-4
g4lefttilex=(g4xpos+3)/20
g4lefttiley=(g4ypos+8)/20
g4righttilex=(g4xpos+24)/20
g4righttiley=(g4ypos+4)/20
g4uptilex=(g4xpos+5)/20
g4uptiley=(g4ypos+3)/20
g4downtilex=(g4xpos+5)/20
g4downtiley=(g4ypos+24)/20
End Function

Function g4chasedirection()
a=Rand(1,4)
If a =4 Then g4chase=0
	If g4chase=1
			If tile(g4uptilex,g4uptiley) = 0 Or tile(g4uptilex,g4uptiley) =16 Then g4up=1
			If tile(g4downtilex,g4downtiley) = 0 Or tile(g4downtilex,g4downtiley) =16 Then g4down=1
			If tile(g4lefttilex,g4lefttiley) = 0 Or tile(g4lefttilex,g4lefttiley) =16 Then g4left=1
			If tile(g4righttilex,g4righttiley) = 0 Or tile(g4righttilex,g4righttiley) =16 Then g4right=1
				If g4up=1 And ypos<=g4ypos
				g4key=200;:Stop
				If g4left=1 And xpos<=g4xpos And g4xdist>=g4ydist 
					g4key=203
				Else g4left=0
				EndIf
				If g4right=1 And xpos>=g4xpos And g4xdist>=g4ydist
					g4key=205
				Else g4right=0
				EndIf
			EndIf
			If g4down=1 And ypos>=g4ypos
				g4key=208;:Stop
				If g4left=1 And xpos<=g4xpos And g4xdist>=g4ydist
					g4key=203
				Else g4left=0
				EndIf
				If g4right=1 And xpos>=g4xpos And g4xdist>=g4ydist
					g4key=205
				Else g4right=0
				EndIf
			EndIf
			If g4left=1 And xpos<=g4xpos
				g4key=203;:Stop
				If g4up=1 And ypos<=g4ypos And g4ydist>=g4xdist
					g4key=200
				Else g4up=0
				EndIf
				If g4down=1 And ypos>=g4ypos And g4ydist>=g4xdist
					g4key=208
				Else g4down=0
				EndIf
			EndIf
			If g4right=1 And xpos>=g4xpos
				g4key=205;:Stop
				If g4up=1 And ypos<=g4ypos And g4ydist>=g4xdist
					g4key=200
				Else g4up=0
				EndIf
				If g4down=1 And ypos>=g4ypos And g4ydist>=g4xdist
					g4key=208
				Else g4down=0
				EndIf
			EndIf
		EndIf
	End Function



Function drawcarrots();
If carrot1=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxcarrot1,180,65) = 1
	carrot1=0:carroteaten=1
EndIf
If carrot2=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxcarrot1,420,65) = 1
	carrot2=0:carroteaten=1
EndIf
If carrot3=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxcarrot1,180,365) = 1
	carrot3=0:carroteaten=1
EndIf
If carrot4=1 And ImagesOverlap (gfxchicky,xpos,ypos,gfxcarrot1,420,365) = 1
	carrot4=0:carroteaten=1
EndIf


If carrot1=1 Then DrawImage gfxcarrot1,180,65
If carrot2=1 Then DrawImage gfxcarrot2,420,65
If carrot3=1 Then DrawImage gfxcarrot3,180,365
If carrot4=1 Then DrawImage gfxcarrot4,420,365

If carroteaten=1
	time=MilliSecs():test=time :PlaySound sndcarrot
	;Text 100,200,"getting oldtime"
	carroteaten=0: playerchase=1
	g1frame=1
EndIf
If playerchase=1
	nowtime=MilliSecs()
	elapsedtime=nowtime-time
		;Text 100,100,"elapsedtime "+elapsedtime
	;Text 100,150,"nowtime "+nowtime
	;Text 100,175,"test "+test

	If elapsedtime>=10000 Then playerchase=0
	g1chase=0
	
EndIf	

End Function

Function restartmap()
PlaySound sndlevel
;reset all variables except totalscore
xpos=296:ypos=256:xspeed=0:yspeed=0:score=0:chframe=0:g1xpos=296:g1ypos=216
g1xspeed=0:g1yspeed=0:g1status=0:g1chase=0:g1up=0:g1down=0:g1left=0:g1right=0
key=0:carrot1=1:carrot2=1:carrot3=1:carrot4=1:time=0:test=0:g1frame=0:g1dir=0:g1lay=0

g2xpos=296:g2ypos=216
g2xspeed=0:g2yspeed=0:g2status=0:g2chase=0:g2up=0:g2down=0:g2left=0:g2right=0
g2key=0:g2frame=0:g2dir=0:g2lay=0

g3xpos=296:g3ypos=216
g3xspeed=0:g3yspeed=0:g3status=0:g3chase=0:g3up=0:g3down=0:g3left=0:g3right=0
g3key=0:g3frame=0:g3dir=0:g3lay=0

g4xpos=296:g4ypos=216
g4xspeed=0:g4yspeed=0:g4status=0:g4chase=0:g4up=0:g4down=0:g4left=0:g4right=0
g4key=0:g4frame=0:g4dir=0:g4lay=0

fruittemp=0:fruitstatus=0:playerfruit=0:fruitnotshown=0:fruitstart1=0
fruitnotshown=0:fruitstart=0

Delay 3000
loadmap()
End Function

Function gameover()
DrawImage gfxgameover,100,100
Flip
PlaySound sndgameover
Delay 3000
titlescreen=1:lives=3:chalive=1
Cls
Flip
FlushKeys
restartmap()
End Function

Function fruit()
;to see if fruit can now be displayed
If fruitstatus=0 Then fruitstart=MilliSecs():fruitstatus=1
If fruitstatus=1 Then fruitnotshown=MilliSecs()-fruitstart
If fruitnotshown>=20000 Then fruitstatus=2:fruitnotshown=0
If fruitstatus=2 Then DrawImage gfxfruit,300,260
If fruitstatus=2 And ImagesOverlap(gfxchicky,xpos,ypos,gfxfruit,300,260)=1 And chalive=1
	PlaySound sndcarrot
	fruitstatus=3
	totalscore=totalscore+20:accruedscore=accruedscore+20
	playerfruit=1
EndIf
;to see if fruit should disappear
If fruitstatus=2
	If fruittemp=0 Then fruitstart1=MilliSecs():fruittemp=1
	If fruittemp=1
		fruitnotshown1=MilliSecs()-fruitstart1
		If fruitnotshown1>=10000 Then fruitstatus=0:fruittemp=0
	EndIf
EndIf

;to see if foxes should stop laying
If fruitstatus=3 Then fruitstart1=MilliSecs():fruitstatus=4
If fruitstatus=4 
	fruitnotshown1=MilliSecs()-fruitstart1
	If fruitnotshown1>=8000
	  	fruitstatus=0:playerfruit=0:fruittemp=0
		g1lay=0:g2lay=0:g3lay=0:g4lay=0
	EndIf

EndIf

	
If playerfruit=1
	g1lay=1:g2lay=1:g3lay=1:g4lay=1
EndIf


End Function

Function drawtitlescreen()
SetBuffer=BackBuffer()
While titlescreen=1
Cls

DrawImage gfxtitle,80,40
DrawImage gfxchicky,100,180,0
DrawImage gfxghost1,100,220,0
DrawImage gfxghost1,100,260,1
DrawImage gfxghost1,100,300,2
DrawImage gfxcarrot1,100,340
DrawImage gfxfruit,100,380

Text 140,180,"Your little chicky"
Text 140,220,"A bad fox!"
Text 140,260,"An edible fox!"
Text 140,300,"A fox that lays eggs! But NOT edible!!"
Text 140,340,"Yummy carrots that let you eat foxes!"
Text 140,380,"Yummy fruit that changes the nature of foxes"
Text 140,460,"Hit spacebar to start, spacebar to respawn, ESC to quit"
If KeyDown(1) Then End
If KeyDown(57) Then FlushKeys:titlescreen=0
Flip
Wend
End Function

.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,3,2,2,2,2,2,2,2,2,4,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,8,0,1,2,2,4,0,12,0,1,2,2,4,0,8,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,9,0,6,2,2,5,0,9,0,6,2,2,5,0,9,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,11,2,2,4,0,11,2,3,2,10,0,1,2,2,10,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,12,0,0,0,12,0,0,0,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,6,2,2,4,0,6,2,10,0,9,0,11,2,5,0,1,2,2,5,15,0,0,0,0,0,0
Data 0,0,0,0,0,0,15,15,15,12,0,0,0,0,0,0,0,0,0,0,0,12,15,15,15,0,0,0,0,0,0,0
Data 0,0,0,0,0,15,11,2,2,5,0,8,0,1,13,13,13,4,0,8,0,6,2,2,10,15,0,0,0,0,0,0
Data 0,0,0,0,15,16,0,0,0,0,0,12,0,12,15,15,15,12,0,12,0,0,0,0,0,16,15,0,0,0,0,0
Data 0,0,0,0,0,15,11,2,2,4,0,9,0,6,2,2,2,5,0,9,0,1,2,2,10,15,0,0,0,0,0,0
Data 0,0,0,0,0,0,15,15,15,12,0,0,0,0,0,0,0,0,0,0,0,12,15,15,15,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,1,2,2,5,0,1,2,10,0,8,0,11,2,4,0,6,2,2,4,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,12,0,0,0,12,0,0,0,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,11,2,2,5,0,11,2,14,2,10,0,6,2,2,10,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,8,0,1,2,2,4,0,8,0,1,2,2,4,0,8,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,9,0,6,2,2,5,0,12,0,6,2,2,5,0,9,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,6,2,2,2,2,2,2,2,2,14,2,2,2,2,2,2,2,2,5,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0